from data.main import connect, map_tld
import os
from pathlib import Path

def normalize():
    with connect() as db:
        db.sql("""
            SELECT
                p.name
                ,count(1) as ctn
                ,sum(ctn) over() as all
            FROM mbfc.publishers p
            JOIN mbfc.publisher_stories ps
            ON ps.publisher_id = p.id
            JOIN stories s
            ON s.id = ps.story_id
            GROUP BY
                p.name
        """)

    with connect() as db:
        db.sql("""
            SELECT
                bias
                ,count(distinct p.id) as publishers
                ,count(1) as stories
                ,count(1) / count(distinct p.id) as ratio
            FROM mbfc.publishers p
            JOIN mbfc.publisher_stories ps
            ON ps.publisher_id = p.id
            JOIN stories s
            ON s.id = ps.story_id
            GROUP BY
                p.bias
            ORDER BY count(1)
        """)
